/********************************************************************************
Copyright (C), Sinowealth Electronic. Ltd.
Author: 	Sino
Version: 	V0.0
Date: 		2020/04/26
History:
	V2.0	2020/04/26		 Preliminary
********************************************************************************/
#include "Main.h"


/*************************************************************************************************
* : InitVar
*   : 
* ֵ: 
*   : ʼҪǷ0ClrRam()УѽXdata/Idata/Dataȫ
*************************************************************************************************/
void InitVar(void)
{
    ucBalanceStep = BALANCE_ENABLE;
	MemorySet((U8 xdata *)slCadcCurBuf, 0, sizeof(slCadcCurBuf));
	MemorySet((U8 xdata *)Info.uiVCell, 0, sizeof(Info.uiVCell));
	Info.uiTS[0] = 2731;
	Info.uiTS[1] = 2731;

	bSlowDischarge = 0;
	bMidDischarge = 0;
	ucDsgingSpeed = 2;
	bFastDischarge = 1;
    bPorSelfTestFlg = 1;
    
    ucTempeMiddle = 80;
}

/*************************************************************************************************
* : SysParaInit
*   : 
* ֵ: 
*   : MCU FlashȡݣԲֱгʼ
*************************************************************************************************/
void SysParaInit(void)
{
	if(McuFlashCheckFlg(MCUFLASH_BK1_FLG_ADDR))
	{
		McuFlashRead(MCUFLASH_BK1_ADDR, XRAM_MAP_ADDR, 512);
		if(!McuFlashCheckFlg(MCUFLASH_BK2_FLG_ADDR))
		{
			McuFlashWrite(MCUFLASH_BK2_ADDR, XRAM_MAP_ADDR);	//±2
		}
	}
	else if(McuFlashCheckFlg(MCUFLASH_BK2_FLG_ADDR))
	{
		McuFlashRead(MCUFLASH_BK2_ADDR, XRAM_MAP_ADDR, 512);
		McuFlashWrite(MCUFLASH_BK1_ADDR, XRAM_MAP_ADDR);		//±1
	}
	else
	{
		bMcuFlashErr = 1;
		return;
	}
	
	uiPackConfig = E2uiPackConfigMap;
	Info.uiPackConfig = uiPackConfig;
	Info.ulFCC = E2ulFCC;
	Info.uiCycleCount = E2uiCycleCount;
	
    ucCellNum = (uiPackConfig&0x0007)+3;                        //óʼоOffset
    
    if(ucCellNum==5 || ucCellNum==10)
    {
        ucCellNumOffset = 0;
    }
    else if(ucCellNum==4 || ucCellNum==9)
    {
        ucCellNumOffset = 1;
    }
    else
    {
        ucCellNumOffset = 2;
    }
}

/*************************************************************************************************
* : InitIRQ
*   : 
* ֵ: 
*   : ʼж
*************************************************************************************************/
void InitIRQ(void)
{
	IrqDis();                                   //رжԴ
	#if	(UART0_DEFINE != 0)			
	IrqUart0En();						        //ʼUART0жʹܣݾʹUARTģѡ							        //UART0Ƿλָ
	#endif	
	#if	(UART1_DEFINE != 0)
	IrqUart1En();						        //ʼUART1жʹܣݾʹUARTģѡ
	#endif	
	#if	(UART2_DEFINE != 0)
	IrqUart2En();						        //ʼUART2жʹܣݾʹUARTģѡ
	#endif
	
	IrqTimer3FlgClr();					        //ʹTimer3ж
	IrqTimer3En();

	IrqINT4xChEn(INT4_EXS45 | INT4_EXS46);
	IrqINT4Trig(INT4_TRIG_FALLING);		        //½ش
    IrqINT4FlgClr();					        //ⲿжϱ־
    IrqINT4En();                                //ʹⲿж4
    
	IrqEn();
}


/*************************************************************************************************
* : InitGPIO
*   : 
* ֵ: 
*   : ʼI/O˿ڣδʹõI/OĬΪ͵ƽMCU
P0.7[TXD],  P0.6[RXD],  P0.5[SCL],  P0.4[SDA],  P0.3[BLPW], P0.2[],     P0.1[],     P0.0[], 
P0.7ST[1],  P0.6ST[1],  P0.5ST[1],  P0.4ST[1],  P0.3ST[1],  P0.2ST[0],  P0.1ST[0],  P0.0ST[0],  P0 = 0xF8;
P0.7CR[1],  P0.6CR[0],  P0.5CR[0],  P0.4CR[0],  P0.3CR[1],  P0.2CR[1],  P0.1CR[1],  P0.0CR[1],  P0CR = 0x8F;
P0.7PC[1],  P0.6PC[1],  P0.5PC[0],  P0.4PC[0],  P0.3PC[1],  P0.2PC[0],  P0.1PC[0],  P0.0PC[0],  P0PCR = 0xC8;

P1.7[RESET],P1.6[],     P1.5[],     P1.4[],     P1.3[],     P1.2[],     P1.1[], 	P1.0[], 
P1.7ST[1],  P1.6ST[0],  P1.5ST[0],  P1.4ST[0],  P1.3ST[0],  P1.2ST[0],  P1.1ST[0],  P1.0ST[0],  P1 = 0x80;
P1.7CR[0],  P1.6CR[1],  P1.5CR[1],  P1.4CR[1],  P1.3CR[1],  P1.2CR[1],  P1.1CR[1],  P1.0CR[1],  P1CR = 0x7F;
P1.7PC[1],  P1.6PC[0],  P1.5PC[0],  P1.4PC[0],  P1.3PC[0],  P1.2PC[0],  P1.1PC[0],  P1.0PC[0],  P1PCR = 0x80;

P2.7[KEY_M],P2.6[ALARM],P2.5[CTLD], P2.4[LED5], P2.3[LED4], P2.2[LED3], P2.1[LED2], P2.0[LED1], 
P2.7ST[1],  P2.6ST[1],  P2.5ST[1],  P2.4ST[0],  P2.3ST[0],  P2.2ST[0],  P2.1ST[0],  P2.0ST[0],  P2 = 0xE0;
P2.7CR[0],  P2.6CR[0],  P2.5CR[1],  P2.4CR[1],  P2.3CR[1],  P2.2CR[1],  P2.1CR[1],  P2.0CR[1],  P2CR = 0x3F;
P2.7PC[1],  P2.6PC[1],  P2.5PC[0],  P2.4PC[0],  P2.3PC[0],  P2.2PC[0],  P2.1PC[0],  P2.0PC[0],  P2PCR = 0xC0;

P3.7[],     P3.6[],     P3.5[LED6], P3.4[XTAL1],P3.3[XTAL2],P3.2[],	    P3.1[],     P3.0[KLED], 
P3.7ST[0],  P3.6ST[0],  P3.5ST[0],  P3.4ST[1],  P3.3ST[1],  P3.2ST[0],  P3.1ST[0],  P3.0ST[1],  P3 = 0x19;
P3.7CR[1],  P3.6CR[1],  P3.5CR[1],  P3.4CR[0],  P3.3CR[0],  P3.2CR[1],  P3.1CR[1],  P3.0CR[0],  P3CR = 0xE6;
P3.7PC[0],  P3.6PC[0],  P3.5PC[0],  P3.4PC[1],  P3.3PC[1],  P3.2PC[0],  P3.1PC[0],  P3.0PC[1],  P3PCR = 0x19;
*************************************************************************************************/
/*************************************************************************************************
* : InitGPIO_SL
*   : 
* ֵ: 
*   : ʼI/O˿ڣδʹõI/OĬΪ͵ƽMCU
P0.7[TX],  	P0.6[RX],  	P0.5[SCL],  P0.4[SDA],  P0.3[], 	P0.2[],     P0.1[],     P0.0[], 				 	IO״̬:P0.[7,6,5,4,3]Ч
P0.7ST[1],  P0.6ST[1],  P0.5ST[1],  P0.4ST[1],  P0.3ST[0],  P0.2ST[0],  P0.1ST[0],  P0.0ST[0],  P0 = 0xF0;		IO״̬:P0.[7,6,5,4,3]Ч
P0.7CR[1],  P0.6CR[0],  P0.5CR[0],  P0.4CR[0],  P0.3CR[1],  P0.2CR[1],  P0.1CR[1],  P0.0CR[1],  P0CR = 0x8F;	IO:P0.[7,6,5,4,3]Ч,10
P0.7PC[1],  P0.6PC[1],  P0.5PC[0],  P0.4PC[0],  P0.3PC[0],  P0.2PC[0],  P0.1PC[0],  P0.0PC[0],  P0PCR = 0xC0;	ڲ:10ر

P1.7[RESET],P1.6[], 	P1.5[],		P1.4[],     P1.3[],     P1.2[],     P1.1[], 	P1.0[], 					IO״̬:P1.[7,6,5,4,3,2]Ч
P1.7ST[1],  P1.6ST[0],  P1.5ST[0],  P1.4ST[0],  P1.3ST[0],  P1.2ST[0],  P1.1ST[0],  P1.0ST[0],  P1 = 0x80;		IO״̬:P1.[7,6,5,4,3,2]Ч
P1.7CR[0],  P1.6CR[1],  P1.5CR[1],  P1.4CR[1],  P1.3CR[1],  P1.2CR[1],  P1.1CR[1],  P1.0CR[1],  P1CR = 0x7F;	IO:P1.[7,6,5,4,3,2]Ч,10
P1.7PC[1],  P1.6PC[0],  P1.5PC[0],  P1.4PC[0],  P1.3PC[0],  P1.2PC[0],  P1.1PC[0],  P1.0PC[0],  P1PCR = 0x80;	ڲ:10ر

P2.7[],		P2.6[ALARM],P2.5[], 	P2.4[LED],  P2.3[],		P2.2[],  	P2.1[],  	P2.0[485_DE], 				IO״̬:P2.[7,6,5,4,3,2,1,0]Ч
P2.7ST[0],  P2.6ST[1],  P2.5ST[0],  P2.4ST[0],  P2.3ST[0],  P2.2ST[1],  P2.1ST[1],  P2.0ST[0],  P2 = 0x46;		IO״̬:P2.[7,6,5,4,3,2,1,0]Ч
P2.7CR[1],  P2.6CR[0],  P2.5CR[1],  P2.4CR[1],  P2.3CR[1],  P2.2CR[0],  P2.1CR[1],  P2.0CR[1],  P2CR = 0xBB;	IO:P2.[7,6,5,4,3,2,1,0]Ч,10
P2.7PC[0],  P2.6PC[1],  P2.5PC[0],  P2.4PC[0],  P2.3PC[0],  P2.2PC[1],  P2.1PC[1],  P2.0PC[1],  P2PCR = 0x46;	ڲ:10ر

P3.7[],     P3.6[],     P3.5[BAT_V_C], 	P3.4[XTAL1],P3.3[XTAL2],P3.2[],	    P3.1[],     P3.0[BAT_V], 				IO״̬:P3.[5,4,3,...,0]Ч
P3.7ST[0],  P3.6ST[0],  P3.5ST[0], 	    P3.4ST[1],  P3.3ST[1],  P3.2ST[0],  P3.1ST[0],  P3.0ST[0],  P3 = 0x18;		IO״̬:P3.[5,4,3,...,0]Ч
P3.7CR[1],  P3.6CR[1],  P3.5CR[1],      P3.4CR[0],  P3.3CR[0],  P3.2CR[1],  P3.1CR[1],  P3.0CR[0],  P3CR = 0xE6;	IO:P3.[5,4,3,...,0]Ч,10
P3.7PC[0],  P3.6PC[0],  P3.5PC[0],  	P3.4PC[1],  P3.3PC[1],  P3.2PC[0],  P3.1PC[0],  P3.0PC[0],  P3PCR = 0x18;	ڲ:10ر
*************************************************************************************************/
void InitGPIO(void)
{
	
	P0  =   0xF0; 
	P0CR  = 0x8F;
	P0PCR = 0xC0;

	P1  =   0x80;
	P1CR  = 0x7F;
	P1PCR = 0x80;

	P2  =   0x46;
	P2CR  = 0xBB;
	P2PCR = 0x46;	
	
	P3  =   0x18;
	P3CR  = 0xE6;
    P3PCR = 0x18;
	
//UART0IO ڹӳʱעӦIOڵļĴֵ֤ܿʵ	
	#if (UART0_DEFINE == 1)
	P0 |= 0xC0;
	P0PCR |= 0x80;
	#endif
	
	#if	(UART0_DEFINE == 2)
	P0 |= 0x40;
	P2 |= 0x10;
	P2PCR |= 0x10;
	#endif
	
	#if	(UART0_DEFINE == 3)
	P0 |= 0x40;
	P2 |= 0x20;
	P2PCR |= 0x20;
	#endif	
	
	#if	(UART0_DEFINE == 4)
	P0 |= 0x41;
	P0PCR |= 0x01;
	#endif
	
	#if	(UART0_DEFINE == 5)
	P0 |= 0x42;
	P0PCR |= 0x02;
	#endif
	
	#if	(UART0_DEFINE == 6)
	P0 |= 0xC0;
	P0PCR |= 0x40;
	#endif
	
	#if	(UART0_DEFINE == 7)
	P0 |= 0x80;
	P2 |= 0x10;
	P2PCR |= 0x10;
	#endif

	#if	(UART0_DEFINE == 8)
	P0 |= 0x80;
	P2 |= 0x20;
	P2PCR |= 0x20;
	#endif
	
	#if	(UART0_DEFINE == 9)
	P0 |= 0x81;
	P0PCR |= 0x01;
	#endif

	#if	(UART0_DEFINE == 10)
	P0 |= 0x82;
	P0PCR |= 0x02;
	#endif
	
	#if	(UART0_DEFINE == 11)
	P0 |= 0x40;
	P2 |= 0x10;
	P0PCR |= 0x40;
	#endif	

	#if	(UART0_DEFINE == 12)
	P0 |= 0x80;
	P2 |= 0x10;
	P0PCR |= 0x80;
	#endif
	
	#if	(UART0_DEFINE == 13)
	P2 |= 0x30;
	P2PCR |= 0x20;
	#endif

	#if	(UART0_DEFINE == 14)
	P0 |= 0x01;
	P2 |= 0x10;
	P0PCR |= 0x01;
	#endif

	#if	(UART0_DEFINE == 15)
	P0 |= 0x02;
	P2 |= 0x10;
	P0PCR |= 0x02;
	#endif

	#if	(UART0_DEFINE == 16)
	P0 |= 0x40;
	P2 |= 0x20;
	P0PCR |= 0x40;
	#endif	

	#if	(UART0_DEFINE == 17)
	P0 |= 0x80;
	P2 |= 0x20;
	P0PCR |= 0x80;
	#endif
	
	#if	(UART0_DEFINE == 18)
	P2 |= 0x30;
	P2PCR |= 0x10;
	#endif

	#if	(UART0_DEFINE == 19)
	P0 |= 0x01;
	P2 |= 0x20;
	P0PCR |= 0x01;
	#endif

	#if	(UART0_DEFINE == 20)
	P0 |= 0x02;
	P2 |= 0x20;
	P0PCR |= 0x02;
	#endif

	#if	(UART0_DEFINE == 21)
	P0 |= 0x81;
	P0PCR |= 0x80;
	#endif	

	#if	(UART0_DEFINE == 22)
	P0 |= 0x01;
	P2 |= 0x10;
	P2PCR |= 0x10;
	#endif
	
	#if	(UART0_DEFINE == 23)
	P0 |= 0x01;
	P2 |= 0x20;
	P2PCR |= 0x20;
	#endif

	#if	(UART0_DEFINE == 24)
	P0 |= 0x41;
	P0PCR |= 0x40;
	#endif

	#if	(UART0_DEFINE == 25)
	P0 |= 0x03;
	P0PCR |= 0x02;
	#endif
	
	#if	(UART0_DEFINE == 26)
	P0 |= 0x82;
	P0PCR |= 0x80;
	#endif	

	#if	(UART0_DEFINE == 27)
	P0 |= 0x02;
	P2 |= 0x10;
	P2PCR |= 0x10;
	#endif
	
	#if	(UART0_DEFINE == 28)
	P0 |= 0x02;
	P2 |= 0x20;
	P2PCR |= 0x20;
	#endif

	#if	(UART0_DEFINE == 29)
	P0 |= 0x42;
	P0PCR |= 0x40;
	#endif

	#if	(UART0_DEFINE == 30)
	P0 |= 0x03;
	P0PCR |= 0x01;
	#endif
	
//UART1IO	
	#if (UART1_DEFINE == 1)
		P1 |= 0x03;
		P1PCR |= 0x02;
	#endif
	
	#if (UART1_DEFINE == 2)
		P1 |= 0x01;
		P3 |= 0x08;
		P3PCR |= 0x08;
	#endif
	
	#if (UART1_DEFINE == 3)
		P1 |= 0x01;
		P3 |= 0x10;
		P3PCR |= 0x10;
	#endif
	
	#if (UART1_DEFINE == 4)
		P1 |= 0x01;
		P2 |= 0x40;
		P2PCR |= 0x40;
	#endif
	
	#if (UART1_DEFINE == 5)
		P1 |= 0x01;
		P2 |= 0x80;
		P2PCR |= 0x80;
	#endif
	
	#if (UART1_DEFINE == 6)
		P1 |= 0x03;
		P1PCR |= 0x01;
	#endif
	
	#if (UART1_DEFINE == 7)
		P1 |= 0x02;
		P3 |= 0x08;
		P3PCR |= 0x08;
	#endif
	
	#if (UART1_DEFINE == 8)
		P1 |= 0x02;
		P3 |= 0x10;
		P3PCR |= 0x10;
	#endif
	
	#if (UART1_DEFINE == 9)
		P1 |= 0x02;
		P2 |= 0x40;
		P2PCR |= 0x40;
	#endif
	
	#if (UART1_DEFINE == 10)
		P1 |= 0x02;
		P2 |= 0x80;
		P2PCR |= 0x80;
	#endif
	
	#if (UART1_DEFINE == 11)
		P1 |= 0x01;
		P3 |= 0x08;
		P1PCR |= 0x01;
	#endif
	
	#if (UART1_DEFINE == 12)
		P1 |= 0x02;
		P3 |= 0x08;
		P1PCR |= 0x01;
	#endif
	
	#if (UART1_DEFINE == 13)
		P3 |= 0x18;
		P3PCR |= 0x10;
	#endif
	
	#if (UART1_DEFINE == 14)
		P3 |= 0x08;
		P2 |= 0x40;
		P2PCR |= 0x40;
	#endif
	
	#if (UART1_DEFINE == 15)
		P3 |= 0x08;
		P2 |= 0x80;
		P2PCR |= 0x80;
	#endif
	
	#if (UART1_DEFINE == 16)
		P1 |= 0x01;
		P3 |= 0x10;
		P1PCR |= 0x01;
	#endif
	
	#if (UART1_DEFINE == 17)
		P1 |= 0x02;
		P3 |= 0x10;
		P1PCR |= 0x02;
	#endif
	
	#if (UART1_DEFINE == 18)
		P3 |= 0x18;
		P3PCR |= 0x08;
	#endif
	
	#if (UART1_DEFINE == 19)
		P3 |= 0x10;
		P2 |= 0x40;
		P2PCR |= 0x40;
	#endif
	
	#if (UART1_DEFINE == 20)
		P3 |= 0x10;
		P2 |= 0x80;
		P2PCR |= 0x80;
	#endif
	
	#if (UART1_DEFINE == 21)
		P1 |= 0x01;
		P2 |= 0x40;
		P1PCR |= 0x01;
	#endif
	
	#if (UART1_DEFINE == 22)
		P1 |= 0x02;
		P2 |= 0x40;
		P1PCR |= 0x02;
	#endif
	
	#if (UART1_DEFINE == 23)
		P2 |= 0x40;
		P3 |= 0x08;
		P3PCR |= 0x08;
	#endif
	
	#if (UART1_DEFINE == 24)
		P3 |= 0x10;
		P2 |= 0x40;
		P3PCR |= 0x10;
	#endif
	
	#if (UART1_DEFINE == 25)
		P2 |= 0xC0;
		P2PCR |= 0x80;
	#endif
	
	#if (UART1_DEFINE == 26)
		P1 |= 0x01;
		P2 |= 0x80;
		P1PCR |= 0x01;
	#endif
	
	#if (UART1_DEFINE == 27)
		P1 |= 0x02;
		P2 |= 0x80;
		P1PCR |= 0x02;
	#endif
	
	#if (UART1_DEFINE == 28)
		P2 |= 0x80;
		P3 |= 0x08;
		P3PCR |= 0x08;
	#endif
	
	#if (UART1_DEFINE == 29)
		P3 |= 0x10;
		P2 |= 0x80;
		P3PCR |= 0x10;
	#endif
	
	#if (UART1_DEFINE == 30)
		P2 |= 0xC0;
		P2PCR |= 0x40;
	#endif	
	
//UART2IOãǰdemo˴LEDʾܣִ֧ͨѶdemoΪʹuart2ڹ
	#if (UART2_DEFINE == 1)
		P2 |= 0x06;
		P2PCR |= 0x04;
	#endif
}

/*************************************************************************************************
* : Initial
*   : 
* ֵ: 
*   : ʼ
*************************************************************************************************/
void Initial(void)
{
	McuClockSet(MCU_CLK_24MHz);		            //ϵͳ24MHz
		
	InitGPIO();						            //ʼGPIO

//	ClrRam();                                   //MCU RAMXDATAIDATADATA
	
	SysParaInit();					            //ʼϵͳ
	
	InitVar();						            //ʼ
	
	McuTimer3Set(TIM_CLK_128KHz, 5);            //ʼTimer128KHzþΪ5mS
	
	#if	(UART0_DEFINE != 0)	
		UART0Init();			            //ʼUART0ģ飬9600Bps
	#endif
	
	#if	(UART1_DEFINE != 0)
		UART1Init();			            //ʼUART0ģ飬9600Bps
	#endif
	
	#if	(UART2_DEFINE != 0)	
		UART2Init();			            //ʼUART0ģ飬9600Bps	
	#endif
	
	TwiInit();                      //ʼTWIģ飬ͨѶƵΪ100Khz
	
	McuPWM2Set(4000, 100);			            //ʼPWM2ռձ100%
	
	AFEInitReg();					            //ʼAFEĴ
	if(!AFEInit())					            //ʼAFEMCUAFEV33ģMCUʱAFEѾ׼ͨѶ
	{
		bAfeErr = 1;
	}
	AFEClrFlg();					            //AFE״̬Ĵ
	
	if(bEnEEPRomBK)
	{
		if(!E2PRomInit())
		{
			bE2PRErr = 1;			            //EEPROMģ
		}
		
		if(!RTCInitTime(&RTC))
		{
			bRTCErr = 1;			            //RTCģ
		}
	}
	
	InitIRQ();						            //ʼж
}
