/********************************************************************************
Copyright (C), Sinowealth Electronic. Ltd.
Author: 	Sino
Version: 	V0.0
Date: 		2020/04/26
History:
	V2.0	2020/04/26		 Preliminary
********************************************************************************/
#include "Main.h"


BOOL bSleepFlg;                                             //ϵͳIDLE־
BOOL bPDFlg;
BOOL bWakeupFlg;
BOOL bPCEnterPDFlg;                                         //PC֪ͨϵͳSLEEP־
U8  xdata ucSleepTimerCnt;
U8  xdata ucPDTimerCnt;
U8  xdata ucResetFlag;

/*************************************************************************************************
* : WakeUpProcess
*   : 
* ֵ: 
*   : SleepģʽѣͨͰ
*************************************************************************************************/
void WakeUpProcess(void)
{
	if(bWakeupFlg)
	{
		bWakeupFlg = 0;
		if(bSleepFlg)
		{
			McuClockSet(MCU_CLK_24MHz);
            IrqEn();
            
			bSleepFlg = 0;
			ucSleepTimerCnt = 0;
			Delay1ms(1);
			
			#if	(UART0_DEFINE != 0)			
			IrqUart0En();						       		//uart0ж						        
			#endif	
			IrqTimer3En();                                  //Timer3ж
			McuTwiEn();                                     //MCU Twiģ
				
			AfeAlarmDis(AFE_ALARM_SC | AFE_ALARM_OV | AFE_ALARM_CD);
			AfeTempADCEn();							//AFE¶Ȳɼ
			AfeWDTEn();                                    //AFE WDT
		}
		ucSleepTimerCnt = 0;
		ucPDTimerCnt = 0;
		ucUart0TimeoutCnt = 0;
		ucUart1TimeoutCnt = 0;
		ucUart2TimeoutCnt = 0;
	}
}


/*************************************************************************************************
* : SystemIntoPD
*   : 
* ֵ: 
*   : ϵͳģʽ
*************************************************************************************************/
void SystemIntoPD(void)
{
	while(1)
    {
        McuWDTClear();                                      //Ź
        
        IrqDis();                                           //رжԴ
//        LEDAllOff();                                        //رLEDʾ
        BlueToothPowerDis();                                //رģ
        AFEMosCtl(0);                                       //رMOS
        
        AFEEnterPD();                                       //ر3.3VԴ
    }
}


/*************************************************************************************************
* : SystemIntoSleep
*   : 
* ֵ: 
*   : ͹ĴIDLEPD
*************************************************************************************************/
void SystemIntoSleep(void)    
{	
//	LEDAllOff();                                            //رLEDʾ
	BlueToothPowerDis();                                    //رģ
	bLedDisBleFlg = 0;

	AfeWDTDis();                                            //رAFE WDT
	AfeTempADCDis();									//رAFE¶Ȳɼ
	AfeAlarmEn(AFE_ALARM_SC | AFE_ALARM_OV | AFE_ALARM_CD);	//SC,OV,CDAlarm
	McuTwiDis();                                            //رMCU Twiģ齵͹
	McuPWM2Dis();                                           //رMCU PWMģ
	if(bDSGMOS)                                             //DSGʱֱߵƽ
	{
		IO_DSG_PWM = 1;
	}
	else
	{
		IO_DSG_PWM = 0;
	}
	Delay1ms(1);

	IrqDis();                                               //رжԴ
	#if	(UART0_DEFINE != 0)	
	IrqUart0Dis();
	#endif
	#if	(UART1_DEFINE != 0)
	IrqUart1Dis();
	#endif
	#if	(UART2_DEFINE != 0)
	IrqUart2Dis();
	#endif
	IrqTimer3Dis();                                         //رTimer3ж
	IrqINT4FlgClr();                                        //ⲿж4־
    McuClockSet(MCU_CLK_128KHz);                            //ϵͳʱΪ128KHz
	IrqEn();
	
	McuIntoPD();                                            //MCUPDͨⲿALARMѡϵͳsleepûйDSG MOSΪСоĿգǣAFEڲԤFUSEVDDѹ4VʱرLDOʹV33ϵ硣
}
	



/*************************************************************************************************
* : LowPowerCheck
*   : 
* ֵ: 
*   : ǷIDLEPD
*************************************************************************************************/
void LowPowerCheck(void)
{
	if(bPCEnterPDFlg && (bUart0SndAckFlg||bUart1SndAckFlg||bUart2SndAckFlg))                     //λǿƽPD
	{
		bPCEnterPDFlg = 0;
		bPDFlg = 1;
	}
    else if(bCTO)                                           //ߺʱPD
    {
		if(++ucPDTimerCnt >= E2ucLowPowerDeley)
		{
			ucPDTimerCnt = E2ucLowPowerDeley;
			bPDFlg = 1;
		}
    }
	else if(!bLedDisFlg)                                    //LEDʾرպʼ͹
	{
		if(!bCHGING && !bDSGING)                            //ǳǷ״̬
		{
			if(bUV)                                         //ǷѹʱPD
			{
				if(++ucPDTimerCnt >= E2ucLowPowerDeley)
				{
					ucPDTimerCnt = E2ucLowPowerDeley;
					bPDFlg = 1;
				}
			}
			else                                            //δǷѹδʱIDLE
			{
                ucPDTimerCnt = 0;
                if(!(bOTC | bUTC | bOV | bOCC | bOTD | bUTD | bUV | bOCD1 | bOCD2 | bAFE_SC | bLedDisBleFlg))
                {
    				if(++ucSleepTimerCnt >= E2ucLowPowerDeley)
    				{
    					ucSleepTimerCnt = E2ucLowPowerDeley;
    					bSleepFlg = 1;
    				}
                }
                else
                {
                    ucSleepTimerCnt = 0;
                }
			}
		}
		else
		{
			ucSleepTimerCnt = 0;
			ucPDTimerCnt = 0;
		}
	}
	else
	{
		ucSleepTimerCnt = 0;
		ucPDTimerCnt = 0;
	}
}


/*************************************************************************************************
* : LowPowerProcess
*   : 
* ֵ: 
*   : ͹ĴIDLEPD
*************************************************************************************************/
void LowPowerProcess(void)
{
	if(!bSleepFlg && !bPDFlg)
	{
		IrqDis();
		if(!(bKeyFlg | bCaliFlg | bMcuFlashWrFlg | bWakeupFlg | bISPFlg | bTimer50msFlg | bTimer1sFlg) && (ucResetFlag!=0x12))
		{
			IrqEn();
			McuIntoIdle();
		}
		IrqEn();
	}
	else if(bPDFlg)
	{
		bMcuFlashWrFlg = 1;
		McuFlashProcess();
		SystemIntoPD();
	}
	else if(bSleepFlg)
	{
		SystemIntoSleep();
	}
	
	WakeUpProcess();                                        //ϵͳӵ͹Ļ
}


