/********************************************************************************
Copyright (C), Sinowealth Electronic. Ltd.
Author: 	Sino
Version: 	V0.0
Date: 		2020/04/26
History:
	V2.0	2020/04/26		 Preliminary
********************************************************************************/
#include "Main.h"

//AFEصı
BOOL bAfeAlarmFlg;
BOOL bCADCFlg;
BOOL bVADCFlg;
BOOL bAfeI2CRWErrFlg;
BOOL bAfeErr;
U8	data ucCellNum;                                 //ǰӲо
U8	data ucCellNumOffset;                           //ǰӲоӷʽӦƫƣڳȡAFEӦĴ
U16	data uiCellVmax;                                //оѹֵ
U16	data uiCellVmin;                                //оѹСֵ
U16	xdata uiVadcVmax;                               //ADCɼֵ
U16	xdata uiVadcVmin;                               //ADCɼСֵ
U8	xdata ucTempeMiddle;
U16 xdata uiTempeMin;
U16 xdata uiTempeMax;
S32 xdata slCadcCurrent;
S32 xdata slCadcCurAverage;
U8  xdata ucCadcCnt;
S32 xdata slCadcCurBuf[16];
U8	xdata ucAfeI2CErrDelayCnt;
SYSINFOR xdata Info;                                //ֵ
AFEDATA  xdata AFE;                                 //AFEĴȡֵ
AFEREG   xdata REG;                                 //AFEĴԤֵ



/*************************************************************************************************
* : AFETwiCheck
*   : 
* ֵ: 
*   : 5S⵽AFEI2CͨѶλbAfeErr=1
*************************************************************************************************/
void AFETwiCheck(void)
{
	if(bAfeI2CRWErrFlg)
	{
		if(++ucAfeI2CErrDelayCnt >= TIME_1S_5S)
		{
			bAfeErr = 1;
			ucAfeI2CErrDelayCnt = TIME_1S_5S;
		}
	}
	else
	{
		ucAfeI2CErrDelayCnt = 0;
	}
}


/*************************************************************************************************
* : AFEWriteReg
*   : RegĴַ
		  WrBufдݣ1Byte+1Byte CRC
* ֵ: 1:ɹ0:ʧ
*   : дAFEĴÿдһĴ
*************************************************************************************************/
BOOL AFEWriteReg(U8 Reg, U8 Length, U8 xdata *WrBuf)
{
    BOOL Result = 0;
    U8 Times = 0;
    U8 i;

	if(!bAfeErr)
	{
        for(i=0; i<Length; i++)
    	{
		while(Times++ < 5)
		{
			#ifdef TWI_Hardware_Module 
			{
                Result = TwiWrite(AFE_ID, Reg, TWI_ADDR_1B, 1, TWI_CRC_YES, WrBuf);
			}
			#else
			{
				Result = TwiWrite(AFE_ID, Reg, 1, WrBuf);
			}
			#endif
			if(Result)
			{
				break;
			}
			else
			{
                TWICON = 0;                         //Close TWI module
				Delay1ms(1);
                TwiInit();              //Reinitial
                Delay1ms(1);
			}
		}
            if(Times >= 5)
            {
                break;
            }
            else
            {
                Times = 0;
                Reg++;
                WrBuf++;
            }
			Delay1ms(1);
     	}
	}
	bAfeI2CRWErrFlg = !Result;                      //ͨѶǷ

    return  Result;
}


/*************************************************************************************************
* : AFEReadReg
*   : RegĴַ
		  RdBufݣ2Byte+1Byte CRC
* ֵ: 1:ɹ0:ʧ
*   : AFEĴÿĴ
*************************************************************************************************/
BOOL AFEReadReg(U8 Reg, U8 Length , U8 xdata *RdBuf)
{
    BOOL Result = 0;
    U8 Times = 0;

	if(!bAfeErr)
	{
		while(Times++ < 5)                          //Try 5
		{
			#ifdef TWI_Hardware_Module
                Result = TwiRead(AFE_ID, Reg, TWI_ADDR_1B, Length, TWI_CRC_YES, RdBuf);
			#else
				Result = TwiRead(AFE_ID, Reg, Length, RdBuf);
			#endif
			if(Result)                              //ɹCRCУȷ˳ѭسɹ־
			{
				break;
			}
			else                                    //TWICRCУʧܣʱ1mS֮ٶȡ
			{
				TWICON = 0;                         //Close TWI module
				Delay1ms(1);
                TwiInit();              //Reinitial
                Delay1ms(1);
			}
		}
	}
	bAfeI2CRWErrFlg = !Result;                      //ͨѶǷ

    return  Result;
}


/*************************************************************************************************
* : AFEClrFlg
*   : 
* ֵ: 
*   : AFE־Ĵ
*************************************************************************************************/
void AFEClrFlg(void)
{
	if(AFEReadReg(AFE_FLAG1, 2, &REG.AFEFLAG1))
    {
        if((REG.AFEFLAG1!=0) || (REG.AFEFLAG2!=0))
        {
            REG.AFESCONF1 |= 0x80;
            AFEWriteReg(AFE_SCONF1, 1, &REG.AFESCONF1);
            REG.AFESCONF1 &= ~0x80;
            AFEWriteReg(AFE_SCONF1, 1, &REG.AFESCONF1);
        }
    }
}


/*************************************************************************************************
* : AFEInitReg
*   : 
* ֵ: 
*   : ʼAFEĴ
*************************************************************************************************/
void AFEInitReg(void)
{
	U16 TempVar;
	
	REG.AFEINTEN  = 0x00;                           //ȡѯʽʲҪALARMж
	REG.AFESCONF1 = 0x50;                           //ʹCTLDWDT
	REG.AFESCONF2 = 0x00;							//AFEΪλźţALARM͵ƽ壬ŵMOSMOSر
	REG.AFESCONF3 = 0xF8;                           //ĬVADCCADCCADC10λADCVADCֻɼѹת50ms
	REG.AFESCONF4 = 0x00;							//ĬϹرƽBAT6-10
	REG.AFESCONF5 = 0x00;							//ĬϹرƽBAT1-5
	REG.AFESCONF6 = 0x70;							//CADCɼ200mVΧλźſ1SӲ·ѹ100mVӲ·ʱ50uS
	REG.AFESCONF7 = 0x01;                           //Ӳ屣ʱ1תڣŵ״ֵ̬ѡλ1.4mVÿŹ10S
	REG.AFESCONF8 = 0x03;							//SCONF8 + SCONF9 = 11 1111 1111 = 1023
	REG.AFESCONF9 = 0xff;							//Ӳ屣ֵ1023*5.86mV = 5994.78
	REG.AFESCONF10= 0x00;							//͹Ŀλд0x33дPD_EN=1͹
	
    if(bSC_EN)                                      //ʹAFE·
    {
        REG.AFESCONF1 |= 0x08;
        REG.AFESCONF6 |= (E2ucAFEProtectConfig&0x0f);//FLASHڲдAFEĴ
    }
    if(bOV_EN)                                      //ʹAFEѹ
    {
        REG.AFESCONF1 |= 0x04;
        REG.AFESCONF7 |= (E2ucAFEProtectConfig&0xf0);//FLASHڲдAFEĴ
        TempVar = (U32)E2uiAFEOVvol*50/293;			 //ȡѹѹ
        REG.AFESCONF8 = TempVar>>8;					 //дλ
        REG.AFESCONF9 = TempVar;					 //дͰλ
    }
}



/*************************************************************************************************
* : AFEInit
*   : 
* ֵ: 1:ɹ0:ʧ
*   : ʼAFE
*************************************************************************************************/
BOOL AFEInit(void)
{
	U8 xdata RdBuf[2];
	U8 i;
    BOOL Result = 1;
	U8 j = 3;
	
	while(j--)
	{    
		if( AFEWriteReg(AFE_INT_EN, 11, &REG.AFEINTEN))
		{	
			for(i=3; i<=11; i=i+2)
			{
				AFEReadReg(i, 2, RdBuf);
		
				if((RdBuf[0]!=*(&REG.AFEFLAG1+i)) || (RdBuf[1]!=*(&REG.AFEFLAG1+i+1)))
				{
					if(i != 7)                              //ƽĴ⣬ΪƽĴλ30sԶ
					{
						Result = 0;
						break;
					}
				}
			}			
		}
		else
		{
			Result = 0;
		}
		if(Result)
		{
			break;
		}				
	}
	return Result;
	
}


/*************************************************************************************************
* : AFERdFlg
*   : 
* ֵ: 
*   : ȡAFE־Ĵ
		  AFE_SCʾ·
          FLAG2bit2Ϊ1ʾLVRλҪ³ʼAFE
*************************************************************************************************/
void AFERdFlg(void)
{
	if(AFEReadReg(AFE_FLAG1, 2, &REG.AFEFLAG1))
    {
        if((REG.AFEFLAG2&0x02) != 0)                //CADC ת
        {
            bCADCFlg = 1;
        }

        if((REG.AFEFLAG2&0x01) != 0)                //VADC ѹת
        {
            bVADCFlg = 1;
        }

        if((REG.AFEFLAG1&0x08) != 0 && (bLoadChkingFlg != 1))                //AFE·
        {
            bAFE_SC = 1;
            bLoadStartCheckFlg = 1;                 //ؼ
        }
        if((REG.AFEFLAG1&0x04) != 0)                //AFE Ӳѹ
        {
            bAFE_OV= 1;        
        }

        if((REG.AFEFLAG2&0x04) != 0)                //жFLAG2bit2ǷΪ1Ϊ1ʾAFELVRҪ³ʼAFEĴ
        {
            AFEInit();
        }
    }
}


/*************************************************************************************************
* : AFERdStatus
*   : 
* ֵ: 
*   : ȡAFE״̬Ĵ
*************************************************************************************************/
void AFERdStatus(void)
{
	U8	RegTemp[2];
	if(AFEReadReg(AFE_BSTATUS, 2, RegTemp))//&REG.AFEBSTATUS))//AFE̶2Bytesֻȡ1Byte
    {
        ucAFEStatus = REG.AFEBSTATUS = RegTemp[0];               //³صļ
    }
}


/*************************************************************************************************
* : AFERamCheck
*   :
* ֵ: 
*   : ʱAFEļĴǷ񱻸д³ʼ
*************************************************************************************************/
void AFERamCheck(void)
{
	U8 xdata RdBuf[2];
	U8 i;
	
	for(i=3; i<=11; i=i+2)
	{
		AFEReadReg(i, 2, RdBuf);

        if((RdBuf[0]!=*(&REG.AFEFLAG1+i)) || (RdBuf[1]!=*(&REG.AFEFLAG1+i+1)))
        {
			if(i != 7)                              //ƽĴ⣬ΪƽĴλ30sԶ
			{
				if(!AFEInit())
			    {
					bPDFlg = 1;
			    }				
	            break;
			}
        }
	}
}


/*************************************************************************************************
* : AFEEnterPD
*   : 
* ֵ: 
*   : AFEPD״̬ر3.3V
*************************************************************************************************/
void AFEEnterPD(void)
{
	REG.AFESCONF10 = 0x33;
	if(AFEWriteReg(AFE_SCONF10, 1, &REG.AFESCONF10))
    {
        REG.AFESCONF1 |= 0x20; 
        AFEWriteReg(AFE_SCONF1, 1, &REG.AFESCONF1);
    }
}


/*************************************************************************************************
* : AFEMosCtl
*   : MosStatusMOS״̬10ر
* ֵ: 
*   : ƳŵMOSĿ͹ر
*************************************************************************************************/
void AFEMosCtl(U8 MosStatus)
{
	REG.AFESCONF2 &= ~0x03;
	REG.AFESCONF2 |= MosStatus;
	AFEWriteReg(AFE_SCONF2, 1, &REG.AFESCONF2);
}



/*************************************************************************************************
* : AFEChgerCheckEnAFEChgerCheckDisAFELoadCheckEnAFELoadCheckDis
*   : 
* ֵ: 
*   : ʹ/رճ⡢ؼ
*************************************************************************************************/
void AFEChgerCheckEn(void)
{
	REG.AFESCONF1 |= 0x01;
	AFEWriteReg(AFE_SCONF1, 1, &REG.AFESCONF1);
}


void AFEChgerCheckDis(void)
{
	REG.AFESCONF1 &= ~0x01;
	AFEWriteReg(AFE_SCONF1, 1, &REG.AFESCONF1);
}


void AFELoadCheckEn(void)
{
	REG.AFESCONF1 |= 0x02;
	AFEWriteReg(AFE_SCONF1, 1, &REG.AFESCONF1);
}


void AFELoadCheckDis(void)
{
	REG.AFESCONF1 &= ~0x02;
	AFEWriteReg(AFE_SCONF1, 1, &REG.AFESCONF1);
}


/*************************************************************************************************
* : AfeBalEn
*   : BalChTempƽӦCELLȫΪ0رƽ
* ֵ: 
*   : ͹رƽ
*************************************************************************************************/
void AfeBalCtl(U16 BalChTemp)
{
	REG.AFESCONF4 = BalChTemp>>5;
	if(AFEWriteReg(AFE_SCONF4, 1, &REG.AFESCONF4))
    {
        REG.AFESCONF5 = BalChTemp;
        AFEWriteReg(AFE_SCONF5, 1, &REG.AFESCONF5);
    }
}


/*************************************************************************************************
* : AfeWDTEn AfeWDTDis
*   : 
* ֵ: 
*   : ͹رտŹģ
*************************************************************************************************/
void AfeWDTEn(void)
{
	REG.AFESCONF1 |= 0x10;
	AFEWriteReg(AFE_SCONF1, 1, &REG.AFESCONF1);
}


void AfeWDTDis(void)
{
	REG.AFESCONF1 &= ~0x10;
	AFEWriteReg(AFE_SCONF1, 1, &REG.AFESCONF1);
}


/*************************************************************************************************
* : AfeWDTEn AfeWDTDis
*   : 
* ֵ: 
*   : ͹رտŹģ
*************************************************************************************************/
void AfeADCEn(void)
{
	REG.AFESCONF3 |= 0xf8;
	AFEWriteReg(AFE_SCONF3, 1, &REG.AFESCONF3);
}


void AfeADCDis(void)
{
	REG.AFESCONF3 &= ~0xf8;
	AFEWriteReg(AFE_SCONF3, 1, &REG.AFESCONF3);
}

void AfeCADCEn(void)
{
	REG.AFESCONF3 |= 0xe0;
	AFEWriteReg(AFE_SCONF3, 1, &REG.AFESCONF3);
}


void AfeCADCDis(void)
{
	REG.AFESCONF3 &= ~0xe0;
	AFEWriteReg(AFE_SCONF3, 1, &REG.AFESCONF3);
}

void AfeTempADCEn(void)
{
	REG.AFESCONF3 |= 0x08;
	AFEWriteReg(AFE_SCONF3, 1, &REG.AFESCONF3);
}


void AfeTempADCDis(void)
{
	REG.AFESCONF3 &= ~0x08;
	AFEWriteReg(AFE_SCONF3, 1, &REG.AFESCONF3);
}


/*************************************************************************************************
* : AfeAlarmEnAfeAlarmDis
*   : AlarmFlgλӦALARMλ
* ֵ: 
*   : ͹رնӦALARMжϴ
*************************************************************************************************/
void AfeAlarmEn(U8 AlarmFlg)
{
	REG.AFEINTEN |= AlarmFlg;
	AFEWriteReg(AFE_INT_EN, 1, &REG.AFEINTEN);
}

void AfeAlarmDis(U8 AlarmFlg)
{
	REG.AFEINTEN &= ~AlarmFlg;
	AFEWriteReg(AFE_INT_EN, 1, &REG.AFEINTEN);
}


