/********************************************************************************
Copyright (C), Sinowealth Electronic. Ltd.
Author: 	Sino
Version: 	V0.0
Date: 		2020/04/26
History:
	V2.0	2020/04/26		 Preliminary
********************************************************************************/
#include "Main.h"


BOOL	bMcuFlashWrWaitFlg;
BOOL	bMcuFlashWrFlg;
BOOL	bMcuFlashErr;
U8	xdata	ucMcuFlashWrValid;
U8	xdata	bMcuFlashWrWaitCnt;

/*************************************************************************************************
* : McuFlashWrOneByte
*   : McuFlashAddrʼַWrDataдע
* ֵ: 
*   : д1ֽ
*************************************************************************************************/
void McuFlashWrOneByte(U16 McuFlashAddr, U8 WrData)
{
    IrqDis();
	McuFlashEn();
	
    XPAGE = McuFlashAddr>>8;
    IB_OFFSET = McuFlashAddr % 256;
    IB_DATA = WrData;

    IB_CON1 = 0x6E;	
    IB_CON2 = 0x05;
    IB_CON3 = 0x0A;
    IB_CON4 = 0x09;
	if(XPAGE == (McuFlashAddr>>8))
	{
		IB_CON5 = 0x06;
		_nop_();
		_nop_();
		_nop_();
		_nop_();
		_nop_();
	}
	
    McuFlashDis();
	IrqEn();
}


/*************************************************************************************************
* : McuFlashBlankCheck
*   : McuFlashAddrʼַ
* ֵ: 0ȫ0Eraseʧܣ1ȫ0Eraseɹ
*   : Erase1SectorǷȫΪ0
*************************************************************************************************/
BOOL McuFlashBlankCheck(U16 McuFlashAddr)
{
	BOOL Result = 1;
    U16 i;
    
    for(i=0; i<MCUFLASH_SECTOR_SIZE; i++)
    {
        if(CBYTE[McuFlashAddr+i] != 0x00)
        {
            Result = 0;
			break;
        }
    }
    
    return Result;
}


/*************************************************************************************************
* : McuFlashDataCheck
*   : McuFlashAddrʼַ
* ֵ: 0У1Уȷ
*   : У鱻дSectorǷXRAMһ
*************************************************************************************************/
BOOL McuFlashDataCheck(U16 McuFlashAddr, U16 XramAddr)
{
	BOOL Result = 1;
    U8 xdata *ptr = (U8 xdata *)XramAddr;                   //ǿƽֵΪֵַָ
    U16 i;
    
    for(i=0; i<MCUFLASH_SECTOR_SIZE; i++)
    {
        if(CBYTE[McuFlashAddr+i] != *(ptr+i))
        {
            Result = 0;
			break;
        }
    }
	
    return Result;
}


/*************************************************************************************************
* : McuFlashWrSector
*   : 
* ֵ: 
*   : д1Sector
*************************************************************************************************/
BOOL McuFlashWrSector(U16 McuFlashAddr, U16 XramAddr)
{
    BOOL Result = 0;
    U16 i;
    U8 xdata *ptr = (U8 xdata *)XramAddr;                   //ǿƽֵΪֵַָ
    
    for(i=0; i<MCUFLASH_SECTOR_SIZE; i++)
    {
        IB_OFFSET = McuFlashAddr+i;
        XPAGE = (McuFlashAddr+i)>>8;
        IB_DATA = *(ptr+i);
		IB_CON1 = 0x6E;
		if(!EA)
		{
			IB_CON2 = 0x05;
			if(FLASHCON)
			{
				IB_CON3 = 0x0A;
				if(ucMcuFlashWrValid == 0x55)
				{
					IB_CON4 = 0x09;
					if(XPAGE == ((McuFlashAddr+i)>>8))
					{
						IB_CON5 = 0x06;
						_nop_();
						_nop_();
						_nop_();
						_nop_();
						_nop_();
						Result = 1;
					}
					else
					{
						Result = 0;
						break;
					}
				}
				else
				{
					Result = 0;
					break;
				}
			}
			else
			{
				Result = 0;
				break;
			}
		}
		else
		{
			Result = 0;
			break;
		}
    }
	
    return Result;
}


/*************************************************************************************************
* : McuFlashWrite
*   : McuFlashAddrдĵַȹ̶Ϊ1Sector
* ֵ: 0дʧܣ1дɹ
*   : дMCU Flash1Sector:
          1.Erase Sector
          2.鵱ǰSectorǷȫΪ0
          3.XRAMд
          4.УXRAMMCU FlashǷһ
*************************************************************************************************/
BOOL McuFlashWrite(U16 McuFlashAddr, U16 XramAddr)
{
    BOOL Result = 0;
	
	McuWDTClear();                      //忴Ź
	IrqDis();                           //رжԴ
	McuFlashEn();
	
	XPAGE = McuFlashAddr >> 8;
	IB_CON1 = 0xE6;
	if(!EA)
	{
		IB_CON2 = 0x05;
		if(FLASHCON)
		{
			IB_CON3 = 0x0A;
			if(ucMcuFlashWrValid == 0x55)
			{
				IB_CON4 = 0x09;
				if(XPAGE == (McuFlashAddr >> 8))
				{
					IB_CON5 = 0x06;
					_nop_();
					_nop_();
					_nop_();
					_nop_();
					_nop_();

					if(McuFlashBlankCheck(McuFlashAddr))					//
					{
						if(McuFlashWrSector(McuFlashAddr, XramAddr))		//д
						{
							if(McuFlashDataCheck(McuFlashAddr, XramAddr))	//У
							{
								Result = 1;
							}
						}
					}
				}
			}
		}
	}

    IB_CON1 = 0;
    IB_CON2 = 0;
    IB_CON3 = 0;
    IB_CON4 = 0;
    IB_CON5 = 0;
    
    McuFlashDis();
    XPAGE = 0x00;
    IrqEn();
    
    return Result;
}






/*************************************************************************************************
* : McuFlashProcess
*   : 
* ֵ: 
*   : дMCU Flashͬʱ±12
*************************************************************************************************/
void McuFlashProcess(void)
{
	BOOL McuFlashBk1WrFailFlg = 0, McuFlashBk2WrFailFlg = 0;
	U16 VoltageMin;
	
	if(bMcuFlashWrFlg)
	{
		bMcuFlashWrFlg = 0;
		
		ucMcuFlashWrValid = 0x55;                           //д־
		if(ucCellNum > 5)                                   //6~10ӦãҪܵѹ10V
		{
			VoltageMin = 10000;
		}
		else                                                //3~5ӦãҪܵѹ5V
		{
			VoltageMin = 5000;
		}
		
		if((Info.ulVoltage>=VoltageMin) && (E2uiCheckFlag==0x5AA5))
		{
			if(!McuFlashWrite(MCUFLASH_BK1_ADDR, XRAM_MAP_ADDR))    //дΣλ־
			{
				if(!McuFlashWrite(MCUFLASH_BK1_ADDR, XRAM_MAP_ADDR))
				{
					McuFlashBk1WrFailFlg = 1;
					E2uiCheckFlag = 0xFFFF;
					McuFlashWrOneByte(MCUFLASH_BK1_ADDR+510,0xFF);
					McuFlashWrOneByte(MCUFLASH_BK1_ADDR+511,0xFF);
				}
			}

			if(!McuFlashWrite(MCUFLASH_BK2_ADDR, XRAM_MAP_ADDR))
			{
				if(!McuFlashWrite(MCUFLASH_BK2_ADDR, XRAM_MAP_ADDR))
				{
					McuFlashBk2WrFailFlg = 1;
					E2uiCheckFlag = 0xFFFF;
					McuFlashWrOneByte(MCUFLASH_BK2_ADDR+510,0xFF);
					McuFlashWrOneByte(MCUFLASH_BK2_ADDR+511,0xFF);
				}	
			}
		}
		else
		{
			McuFlashBk1WrFailFlg = 1;
			McuFlashBk2WrFailFlg = 1;
		}
		ucMcuFlashWrValid = 0x00;
		
		if(McuFlashBk1WrFailFlg && McuFlashBk2WrFailFlg)	//FlashλFlash־
		{
			bMcuFlashErr = 1;
		}
	}
}


/*************************************************************************************************
* : McuFlashRead
*   : SourceAddrԴַTargetAddrĿַLengthݳ
* ֵ: 0ȷ1ݴ
*   : жMCU FlashһֽǷΪ0x5AA5Ƿƻ
*************************************************************************************************/
BOOL McuFlashRead(U16 SourceAddr, U8 xdata *TargetAddr, U16 Length)
{
	U16 i;
    BOOL Result = 1;
    U8 xdata *data TargetAddr1 = TargetAddr;                //*dataؼֵãǰָTargetAddr1data

	IrqDis();
	McuFlashEn();
    McuWDTClear();
    for(i=0; i<Length; i++)
	{
		*TargetAddr1 = CBYTE[SourceAddr+i];
		TargetAddr1++;
	}
	McuFlashDis();
	IrqEn();
	
    return Result;
}


/*************************************************************************************************
* : McuFlashWrWaitCheck
*   : 
* ֵ: 
*   : ҪдMCU FlashʱģҪʱ2Sִдλ޸Ĳģд
*************************************************************************************************/
void McuFlashWrWaitCheck(void)
{
	if(bMcuFlashWrWaitFlg)
	{
	 	if(++bMcuFlashWrWaitCnt >= MCU_FLASH_WATI_DELAY)
		{
			bMcuFlashWrWaitFlg = 0;
		 	bMcuFlashWrWaitCnt = 0;
			bMcuFlashWrFlg = 1;
		}
	}
}


/*************************************************************************************************
* : McuFlashCheckFlg
*   : McuFlashAddrMCU Flashĵַ
* ֵ: 0ȷ1ݴ
*   : жMCU FlashһֽǷΪ0x5AA5Ƿƻ
*************************************************************************************************/
BOOL McuFlashCheckFlg(U16 McuFlashAddr)
{
	BOOL Result = 0;
	
	McuFlashEn();
	if(CWORD[McuFlashAddr/2] == 0x5AA5)
	{
		Result = 1;
	}
	McuFlashDis();
	
	return Result;
}

