/********************************************************************************
Copyright (C), Sinowealth Electronic. Ltd.
Author: 	Sino
Version: 	V0.0
Date: 		2020/04/26
History:
	V2.0	2020/04/26		 Preliminary
********************************************************************************/
#include "Main.h"



/*************************************************************************************************
* : McuTimer3Set
*   : ClkSource: ʱĻ׼ԴֱΪ32KHz128KHz24MHzϵͳʱӣ
          XmSʱڣС1000mSʱѡʱӣڴ1000mSʱֻѡ32KHz128KHz
* ֵ: 
*   : ʼTimer3ʱʱ
*************************************************************************************************/
void McuTimer3Set(U8 ClkSource, U16 XmS)
{
	U16 TempVal;
	
	McuBank1Sel();
	
//	if(ClkSource == TIM_CLK_32KHz)
//	{
//		if(XmS < 1000)
//		{
//			T3CON = 0x02;                               //ⲿ32.768kHzΪʱԴ1Ƶ2S
//			TempVal = (U32)0x10000 - (U32)32.768*XmS;
//		}
//		else
//		{
//			T3CON = 0x22;                               //ⲿ32.768kHzΪʱԴ64Ƶ128s
//			TempVal = 0x10000 - (U32)32.768*XmS/64;
//		}
//	}
//	else if(ClkSource == TIM_CLK_128KHz)
//	{
//		if(XmS < 4000)
//		{
//			T3CON = 0x12;                               //ⲿ128kHzΪʱԴ8Ƶ4.096S
//			TempVal = 0x10000 - (U32)128*XmS/8;
//		}
//		else
//		{
//			T3CON = 0x32;                               //ⲿ128kHzΪʱԴ256Ƶ131.072S
//			TempVal = 0x10000 - (U32)128*XmS/256;
//		}
//	}
//	else if(ClkSource == TIM_CLK_24MHz)
//	{
//        if(XmS < 500)
//		{
//			T3CON = 0x30;                               //ϵͳ24MHzΪʱԴ256Ƶ669.5ms
//            TempVal = 0x10000 - (U32)24000*XmS/256;
//		}
//		else
//		{
//			T3CON = 0x32;                               //ⲿ128kHzΪʱԴ256Ƶ131.072S
//			TempVal = 0x10000 - (U32)128*XmS/256;
//		}
//    }

	//8MHz
	T3CON = 0x30; //ϵͳ8MHzΪʱԴ256Ƶ669.5ms
	TempVal = 0x10000 - (U32)8000*XmS/256;
    
	TL3 = TempVal;
	TH3 = TempVal>>8;
	TR3 = 1;                                            //ʱ3
	
	McuBank0Sel();
}


/*************************************************************************************************
* : McuClockSet
*   : SysClockǰõϵͳʱ
* ֵ: 
*   : ʼAFE
*************************************************************************************************/
void McuClockSet(U8 SysClock)
{
    U8 ea;

    ea = EA;
    EA = 0;
   
    CLKCON  |= 0x08;                      //SETB HFON

	_nop_();
	_nop_();
	_nop_();
	_nop_();
    _nop_();
	_nop_();
	_nop_();
	_nop_();

	CLKCON &= 0x60;

    CLKCON |= 0x04;                                 //SETB	FS, SYSCLK=24M
    
    EA = ea;
}


/*************************************************************************************************
* : McuPWM0SetMcuPWM1SetMcuPWM2Set
*   : PwmFreqPWMƵHzDutyRatioPWMĸߵƽռձ
* ֵ: 
*   : ʼAFE
*************************************************************************************************/
void McuPWM0Set(U16 PwmFreq, U8 DutyRatio)
{
    PWM0CON = 0xb0;                                     //ϵͳʱ/64
    PWM0PL = 375000/PwmFreq;                            //PWM2P=24000000/(64*E2uiDSG1PWMFreq);
	PWM0PH = (375000/PwmFreq) >> 8;
    PWM0DL = (U16)(PWM0PL+PWM0PH*256)*DutyRatio/100;
	PWM0DH = ((U16)(PWM0PL+PWM0PH*256)*DutyRatio/100) >> 8;
}

void McuPWM1Set(U16 PwmFreq, U8 DutyRatio)
{
    PWM1CON = 0xb0;                                     //ϵͳʱ/64
    PWM1PL = 375000/PwmFreq;                            //PWM2P=24000000/(64*E2uiDSG1PWMFreq);
	PWM1PH = (375000/PwmFreq) >> 8;
    PWM1DL = (U16)(PWM1PL+(U16)PWM1PH*256)*DutyRatio/100;
	PWM1DH = ((U16)(PWM1PL+(U16)PWM1PH*256)*DutyRatio/100) >> 8;
}

void McuPWM2Set(U16 PwmFreq, U8 DutyRatio)
{
    PWM2CON = 0xb0;                                     //ϵͳʱ/64
    PWM2PL = 375000/PwmFreq;                            //PWM2P=24000000/(64*E2uiDSG1PWMFreq);
	PWM2PH = (375000/PwmFreq) >> 8;
    PWM2DL = (U16)(PWM2PL+(U16)PWM2PH*256)*DutyRatio/100;
	PWM2DH = ((U16)(PWM2PL+(U16)PWM2PH*256)*DutyRatio/100) >> 8;
}


/*************************************************************************************************
* : Delay1ms
*   : XmsӳٶmS
* ֵ: 
*   : ʱλΪ1mS
رעúʱ׼ȷ⣬ڲͬŻȼʱ಻ͬʱһ£ʵ£
1.ѡĴŻȼΪ3ʱj=1670ֹжϣʵʱΪ3.484msֹжжӰ죬ﵽ3.804ms
2.ѡĴŻȼΪ3ʱj=480ֹжϣʵʱΪ1.010msֹжжӰ죬ﵽ1.104ms
3.ѡĴŻȼΪ7ʱj=1670ֹжϣʵʱΪ1.002msֹжжӰ죬ﵽ1.090ms
*************************************************************************************************/
void Delay1ms(U8 Xms)
{
	U8 i;
	U16 j, Tcnt;
	
	if((CLKCON&0x70) == MCU_CLK_24MHz)
	{
		Tcnt = 1670;
	}
	else if((CLKCON&0x70) == MCU_CLK_12MHz)
	{
		Tcnt = 1670/2;
	}
	else if((CLKCON&0x70) == MCU_CLK_6MHz)
	{
		Tcnt = 1670/4;
	}
	else                                                //2MHz
	{
		Tcnt = 1670/12;
	}

	
	for(i=0; i<Xms; i++)                                //system clock = 24MHz
	{
		for(j=0; j<Tcnt; j++)
		{
		}
	}
}



/*************************************************************************************************
* : ClrRam
*   : 
* ֵ: 
*   : DATAIDATAXRAM򣻶ջ
*************************************************************************************************/
//void ClrRam(void)
//{
// 	U8 idata *ptr1;
//	U8 xdata *ptr2;
//	U8 xdata i;
//	U16 idata j;

//	for(i=0x08; i<=STACK_ADDR-1; i++)                   //clear ram address: 08H~STACK_ADDR-1
//	{
//		ptr1 = (U8 idata *)i;
//		*ptr1 = 0;
//	}

//	for(j=0; j<=0xAFF; j++)                             //clear XDATA address:0000H-0AFFH
//	{
//		ptr2 = (U8 xdata *)j;
//		*ptr2 = 0;
//	}
//}


/*************************************************************************************************
* : RamCheckProcess
*   : 
* ֵ: 
*   : ʱϵͳXRAMı־Ƿȷȷʼ
*************************************************************************************************/
BOOL RamCheckProcess(void)
{
	if((E2ucRamCheckFlg0  != RAM_CHECK_DATA)
	|| (E2ucRamCheckFlg1  != RAM_CHECK_DATA)
	|| (E2ucRamCheckFlg2  != RAM_CHECK_DATA)
	|| (E2ucRamCheckFlg3  != RAM_CHECK_DATA)
	|| (E2ucRamCheckFlg5  != RAM_CHECK_DATA)
	|| (E2ucRamCheckFlg6  != RAM_CHECK_DATA)
	|| (E2ucRamCheckFlg7  != RAM_CHECK_DATA)
	|| (E2ucRamCheckFlg8  != RAM_CHECK_DATA)
	|| (E2ucRamCheckFlg9  != RAM_CHECK_DATA)
	|| (E2ucRamCheckFlgA  != RAM_CHECK_DATA)
	|| (E2ucRamCheckFlgB  != RAM_CHECK_DATA)
	|| (E2uiCheckFlag != 0x5AA5))
	{
		return 0;
	}
	else
	{
		return 1;
	}
}


/*************************************************************************************************
* : MemorySet
*   : pt--memoryָ
		  setval---Ҫֵ
		  length---Ҫֵmemory(Byres)
* ֵ: 
*   : ʱϵͳXRAMı־Ƿȷȷʼ
*************************************************************************************************/
void MemorySet(U8 xdata *pt, U8 setval, U8 length)
{
	U8 i;
	for(i=0; i<length; i++)
	{
		*pt = setval;
		pt++;
	}
}


/*************************************************************************************************
* : MemoryCopy
*   : source--ԴMemoryָ
		  target---ĿMemoryָ
          length---Ҫݳ(Byres)
* ֵ: 
*   : ʱϵͳXRAMı־Ƿȷȷʼ
*************************************************************************************************/
void MemoryCopy(U8 xdata *source, U8 xdata *target, U8 length)
{
	U8 i;
	for(i=0; i<length; i++)
	{
		*target = *source;
		target++;
		source++;
	}
}


/*************************************************************************************************
* : McuIntoIdleMcuIntoPD
*   : 
* ֵ: 
*   : MCUPDģʽIDLEģʽԽ͹
*************************************************************************************************/
void McuIntoIdle(void)
{
	SUSLO = 0x55;
	PCON |= 0x01;
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
}

void McuIntoPD(void)
{
	SUSLO = 0x55;
	PCON |= 0x02;
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
}


/*************************************************************************************************
* : SystemResetProcess
*   : 
* ֵ: 
*   : ϵͳλӳʼַʼִ
*************************************************************************************************/
void SystemResetProcess(void)
{
	if( (ucResetFlag==0x12) && (bUart0SndAckFlg||bUart1SndAckFlg||bUart2SndAckFlg)           //Software reset occurs, and ended UART communication
    && (!bMcuFlashWrWaitFlg) && (!bMcuFlashWrFlg) )     //Flash has been updated
	{
		IrqDis();
		IEN0 = 0x00;                                    //Disable Interrupt
		IEN1 = 0x00;
		TCON = 0x00;
		EXF0 = 0x00;

		SBRTH = 0x00;                                   //Disable UART0
		SBRTL = 0x00;
		SCON = 0x00;
		
		((void(code*)(void))0x0000)();                  //ָʼַ
	}
}








